# -*- coding: utf-8 -*-
###########################################################################
#     Sint Wind PI
#     Copyright 2012 by Tonino Tarsi <tony.tarsi@gmail.com>
#   
#     USB comunication based pywws by 'Jim Easterbrook' <jim@jim-easterbrook.me.uk>
#     Please refer to the LICENSE file for conditions 
#     Visit http://www.vololiberomontecucco.it
# 
##########################################################################
"""Social plugin."""

import threading
import random
import datetime
import sqlite3
import subprocess
import sys 
import os
import thread
import time
import globalvars
import meteodata
from TTLib import *
from twython import Twython, TwythonError
import facebook
import traceback


class swpi_sync_plugin(object):  #  do not change the name of the class
    
    def __init__(self,cfg):
        self.cfg = cfg

        ###################### Plugin Initialization ################
        log("Intitializing sync_plug-in " )
        self.CONSUMER_KEY = 'NljqIkeUeTQslLebDaRQroE3Y'
        self.CONSUMER_SECRET = 'hdaNfy9gHfhoLjbbQ7UzJABtoJYhUfLhphvNiiEWagLRrxeIPl'
        self.ACCESS_KEY = '4046431269-Fh7u67Z8980D0mìA7g5kKiwvQ65t2ZlLj3noNId'
        self.ACCESS_SECRET = 'jO33432a1FM1Y8y62x3j405Z6Y798tnSTRmwEzle3Eh2'
        
        self.facebookcfg = {
                "page_id"      : "44404044412849144",  # 
                "access_token" : "CAAVOe945szYBALPOvDljH6n3TpgDRcPwss9rLa8bStNPDz570PUbNrs0uZCVCeN321754A05gnZCROrqyB3YCoKiHYx6DypMvslFyTD6BidMFYYF7Flp6S4nDd6Qz4mxleZBHddgC9cSbRs2AZ2s4235Z28p1FSYiNXwyKWXvsZBMZAqALXkSVpU3jOuoVvXuZCMZD"   # Step 3
        }
        self.offline = False;
        
    def run_before(self):
        log("Running sync plugin [run_before]..")
        ###################### Plugin run
        

    def run_after(self):
        
        if ( globalvars.takenPicture.cPIFilemane == None  ):
            return
        
        reload(sys)  
        sys.setdefaultencoding('utf8')

#         try:
        log("Running sync plugin [run_after]..")
        
        filename = globalvars.takenPicture.cPIFilemane # globalvars.takenPicture.fotos[0]
        
        # Get Facebook and Twitter API
        twitter = Twython(self.CONSUMER_KEY,self.CONSUMER_SECRET,self.ACCESS_KEY,self.ACCESS_SECRET) 
        graph = facebook.GraphAPI(self.facebookcfg['access_token'])
        resp = graph.get_object('me/accounts')
        page_access_token = None
        for page in resp['data']:
            if page['id'] == self.facebookcfg['page_id']:
                page_access_token = page['access_token']
        graph = facebook.GraphAPI(page_access_token)
        
        mydata = getCurrentMeteoDataFromUrl('http://www.vololiberomontecucco.it/jessica2/meteo.txt')
        if self.offline :
            Messaggio = "#SintWindPI Monte Cucco is OFFLINE"
        else :    
            Messaggio = getTwitterMessage(mydata)
        
        if ( Messaggio != ""  ):
            log("Social_pluging : Twitting ... Message length : "  + str(len(Messaggio)))               
            try:
                ret = twitter.update_status(status=Messaggio)
                #log(ret)
            except TwythonError as e:
                log("Social_pluging : ERROR in Twitting Message ")   
            
        time.sleep(1)
        log("Social_pluging : Twitting ... foto : "  + filename )               
        
        try:
            image_ids = twitter.upload_media(media=open(filename,'rb'))
            theStatus = '#SintWindPI Monte Cucco \n' + time.strftime("%c") + '\n'
            twitter.update_status(status=theStatus , media_ids=image_ids['media_id'])                #twitter.update_status_with_media(media=photo, status='Sint Wind PI ')
            #log(ret)
        except TwythonError as e:
            log("Social_pluging : ERROR in Twitting photo ")   
            
        # FACEBOOK    
        time.sleep(1)
        if self.offline :
            Messaggio = "#SintWindPI Monte Cucco is OFFLINE"
        else :
            Messaggio=getFacebookMessage(mydata)
        log("Social_pluging : Posting on Facebook  ...  : "  + filename )       
        try:
            graph.put_photo(image=open(filename,'rb'), message=Messaggio) 
        except:
            log("Social_pluging : ERROR in Posting on Faceboo ")   
                
#         except Exception,e:
#             log("Social_pluging : Error in Social_pluging plugin")  
#             print e.message
#             print e.__class__.__name__
#             traceback.print_exc(e)   

def getTwitterMessage(mydata):
    if ( mydata == None ):
        return ""
    Messaggio = '#SintWindPI Monte Cucco \n' 
    if (mydata["last_measure_time"] != None) :
        Messaggio += b"\xF0\x9F\x95\x9D" +  "Dati di " + standby(mydata["last_measure_time"]) + "\n"
    if (mydata["wind_dir_code"] != None) :
        Messaggio +=  b"\xF0\x9F\x94\x84" + "Dir. : " + mydata["wind_dir_code"] + "\n"
    if ((mydata["wind_ave"] != None)  and   (mydata["wind_gust"] != None))  :
        Messaggio += b"\xF0\x9F\x92\xA8" +  "Media : " + str(int(mydata["wind_ave"])) + " kmh\n"
        Messaggio += b"\xF0\x9F\x92\xA8" +  "Raffica : " + str(int(mydata["wind_gust"])) + " kmh\n"
    #         if ((mydata["wind_ave"] != None)  and   (mydata["wind_gust"] != None))  :
    #             Messaggio += b"\xF0\x9F\x92\xA8" +  "Med-Max : " + str(int(mydata["wind_ave"])) +  "-" + str(int(mydata["wind_gust"])) + " kmh\n"
    if (mydata["temp_out"] != None):
        Messaggio += b"\xE2\x99\xA8" +       "Temp. : " + str(int(mydata["temp_out"])) + " gradi\n"
    if (mydata["abs_pressure"] != None):
        Messaggio += b"\xF0\x9F\x8F\xA7" +   "Pres. : " + str(int(mydata["rel_pressure"])) + " hpa\n"    
    if (mydata["hum_out"] != None):
        Messaggio += b"\xF0\x9F\x92\xA7" +   "Umidità: " + str(int(mydata["hum_out"])) + " %\n"                    
    if (mydata["cloud_base_altitude"] != None):
        Messaggio += b"\xE2\x98\x81" +       "Cumuli : " + str(int(mydata["cloud_base_altitude"])) + " m\n" 
    return Messaggio

def getFacebookMessage(mydata):
    if ( mydata == None ):
        return ""
    Messaggio = '#SintWindPI Monte Cucco \n' + time.strftime("%c") + '\n' 
    if (mydata["last_measure_time"] != None) :
        Messaggio += b"\xF0\x9F\x95\x9D" +  "Dati di             : " + standby(mydata["last_measure_time"]) + "\n"
    if (mydata["wind_dir_code"] != None) :
        Messaggio +=  "" + "Direzione del Vento : " + mydata["wind_dir_code"] + "\n"
    if ((mydata["wind_ave"] != None)  and   (mydata["wind_gust"] != None))  :
        Messaggio += "" +  "Velocità Media      : " + str(int(mydata["wind_ave"])) + " kmh\n"
        Messaggio += "" +  "Raffica Massima:    : " + str(int(mydata["wind_gust"])) + " kmh\n"
    if (mydata["temp_out"] != None):
        Messaggio += "" +       "Temperatura        : " + str(int(mydata["temp_out"])) + " gradi\n"
    if (mydata["abs_pressure"] != None):
        Messaggio += "" +   "Pressione          : " + str(int(mydata["rel_pressure"])) + " hpa\n"    
    if (mydata["hum_out"] != None):
        Messaggio += "" +   "Umidità            : " + str(int(mydata["hum_out"])) + " %\n"                    
    if (mydata["cloud_base_altitude"] != None):
        Messaggio += "" +       "Base Cumulo : " + str(int(mydata["cloud_base_altitude"])) + " m\n" 
    return Messaggio.encode('utf-8')

def standby(valore):
    valore = valore.replace("[", "")
    valore = valore.replace("]", "")
    valore = valore.replace("-", " ")
    valore = valore.replace("/", "-")

    d1 = datetime.datetime.strptime(valore, "%d-%m-%Y %H:%M:%S")
    d2 = datetime.datetime.strptime(datetime.datetime.today().strftime("%d-%m-%Y %H:%M:%S"), "%d-%m-%Y %H:%M:%S")
    sec = (d2 - d1).seconds
    if (sec < 60) :
        return ("%d secondi fà" % sec) #+ b"\xA0"
    else:
        return ( "%d minuti fà" % int(round(sec / 60, -1)) ) # + b"\xA0"
